package ObservuPlugins::SystemProcesses;



# create a new plugin object
sub new {
    my $class = shift;
    my $self = {
      _config => shift,
      _state => {}
    };
    bless $self, $class;
    return $self;
}


# return a hash with all produced metrics
sub produce_data{
  my($self) = @_;
  
  return read_processes();  
}



sub read_processes {
# TODO: implement
#  ps axo rss,pcpu,comm --sort -rss

  my $result = {};

  my @lines = split("\n", `ps axo rss,pcpu,comm`);
  
  # TODO: group lines by comm, sum  rss and pcpu, add a count field
  
  my $tablestring = "memory:kilobytes\tcpu:percentage\tcommand:string\n";
  my $i=0;
  foreach my $line (@lines) {
    if($i++==0){
      next;
    }
    my @cells = split(" ", $line);
    $tablestring .= join("\t",@cells)."\n";
  }
  
  $result->{"processes:ps_tsv"} = $tablestring;
  
  return $result;

}
